package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLValList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLValList extends JNIObject  {
	
	/* @generated */
	protected ISLValList(long ptr) {
		/*** PROTECTED REGION ID(ISLValList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLValList build(long ptr) {
		return new ISLValList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLValList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_val_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLValList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_val_list_alloc) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLValList.build(ISLNative.isl_val_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLValList vlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_val_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_list_to_string(getNativePtr(vlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_val_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_val_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_val_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_copy 
	 * 
	 * @generated
	**/
	public ISLValList copy() {
		/*** PROTECTED REGION ID(isl_val_list_copy) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLValList.build(ISLNative.isl_val_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_val_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_val_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_n_val 
	 * 
	 * @generated
	**/
	public int getNbVals() {
		/*** PROTECTED REGION ID(isl_val_list_n_val) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_list_n_val(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_get_val 
	 * 
	 * @generated
	**/
	public ISLVal get(int index) {
		/*** PROTECTED REGION ID(isl_val_list_get_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_val_list_get_val(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_set_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLValList set(int index, ISLVal v) {
		/*** PROTECTED REGION ID(isl_val_list_set_val) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLValList.build(ISLNative.isl_val_list_set_val(getNativePtr(this), index, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLValList insert(int pos, ISLVal el) {
		/*** PROTECTED REGION ID(isl_val_list_insert) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLValList.build(ISLNative.isl_val_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLValList add(ISLVal el) {
		/*** PROTECTED REGION ID(isl_val_list_add) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLValList.build(ISLNative.isl_val_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLValList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_val_list_drop) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLValList.build(ISLNative.isl_val_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLValList concat(ISLValList list2) {
		/*** PROTECTED REGION ID(isl_val_list_concat) DISABLED START ***/
		ISLValList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLValList.build(ISLNative.isl_val_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLValList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
